/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.EntCosmos;

import java.io.Serializable;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author obper
 */
@Entity
@Table(name = "wc_usuarios")
@XmlRootElement
@NamedQueries({
        @NamedQuery(name = "WcUsuarios.findAll", query = "SELECT w FROM WcUsuarios w"),
        @NamedQuery(name = "WcUsuarios.findByUsuarioNombre", query = "SELECT w FROM WcUsuarios w WHERE w.usuarioNombre = :usuarioNombre"),
        @NamedQuery(name = "WcUsuarios.findByUsuarioCodigo", query = "SELECT w FROM WcUsuarios w WHERE w.usuarioCodigo = :usuarioCodigo"),
        @NamedQuery(name = "WcUsuarios.findByContrasenia", query = "SELECT w FROM WcUsuarios w WHERE w.contrasenia = :contrasenia"),
        @NamedQuery(name = "WcUsuarios.findByNombreEmpleado", query = "SELECT w FROM WcUsuarios w WHERE w.nombreEmpleado = :nombreEmpleado"),
        @NamedQuery(name = "WcUsuarios.findByCorreo", query = "SELECT w FROM WcUsuarios w WHERE w.correo = :correo"),
        @NamedQuery(name = "WcUsuarios.findByDui", query = "SELECT w FROM WcUsuarios w WHERE w.dui = :dui"),
        @NamedQuery(name = "WcUsuarios.maxUser", query = "SELECT MAX(w.usuarioCodigo) FROM WcUsuarios w"),
        @NamedQuery(name = "WcUsuarios.findByLogueado", query = "SELECT w FROM WcUsuarios w WHERE w.logueado = :logueado")})
public class WcUsuarios implements Serializable {

    private static final long serialVersionUID = 1L;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 15)
    @Column(name = "usuario_nombre")
    private String usuarioNombre;
    @Id
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 3)
    @Column(name = "usuario_codigo")
    private String usuarioCodigo;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 100)
    @Column(name = "contrasenia")
    private String contrasenia;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 45)
    @Column(name = "nombre_empleado")
    private String nombreEmpleado;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 45)
    @Column(name = "correo")
    private String correo;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 10)
    @Column(name = "dui")
    private String dui;
    @Basic(optional = false)
    @NotNull
    @Size(min = 2)
    @Column(name = "sucursal")
    private String sucursal;
    @Basic(optional = false)
    @NotNull
    @Column(name = "logueado")
    private boolean logueado;
    @JoinColumn(name = "grupo_usuario", referencedColumnName = "id_grupos_usuarios")
    @ManyToOne(optional = false, fetch = FetchType.LAZY)
    private WcGruposUsuarios grupoUsuario;

    public WcUsuarios() {
    }

    public WcUsuarios(String usuarioCodigo) {
        this.usuarioCodigo = usuarioCodigo;
    }

    public WcUsuarios(String usuarioCodigo, String usuarioNombre, String contrasenia, String nombreEmpleado, String correo, String dui, boolean logueado) {
        this.usuarioCodigo = usuarioCodigo;
        this.usuarioNombre = usuarioNombre;
        this.contrasenia = contrasenia;
        this.nombreEmpleado = nombreEmpleado;
        this.correo = correo;
        this.dui = dui;
        this.logueado = logueado;
    }

    public String getSucursal() {
        return sucursal;
    }

    public void setSucursal(String sucursal) {
        this.sucursal = sucursal;
    }


    public String getUsuarioNombre() {
        return usuarioNombre;
    }

    public void setUsuarioNombre(String usuarioNombre) {
        this.usuarioNombre = usuarioNombre;
    }

    public String getUsuarioCodigo() {
        return usuarioCodigo;
    }

    public void setUsuarioCodigo(String usuarioCodigo) {
        this.usuarioCodigo = usuarioCodigo;
    }

    public String getContrasenia() {
        return contrasenia;
    }

    public void setContrasenia(String contrasenia) {
        this.contrasenia = contrasenia;
    }

    public String getNombreEmpleado() {
        return nombreEmpleado;
    }

    public void setNombreEmpleado(String nombreEmpleado) {
        this.nombreEmpleado = nombreEmpleado;
    }

    public String getCorreo() {
        return correo;
    }

    public void setCorreo(String correo) {
        this.correo = correo;
    }

    public String getDui() {
        return dui;
    }

    public void setDui(String dui) {
        this.dui = dui;
    }

    public boolean getLogueado() {
        return logueado;
    }

    public void setLogueado(boolean logueado) {
        this.logueado = logueado;
    }

    public WcGruposUsuarios getGrupoUsuario() {
        return grupoUsuario;
    }

    public void setGrupoUsuario(WcGruposUsuarios grupoUsuario) {
        this.grupoUsuario = grupoUsuario;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (usuarioCodigo != null ? usuarioCodigo.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof WcUsuarios)) {
            return false;
        }
        WcUsuarios other = (WcUsuarios) object;
        if ((this.usuarioCodigo == null && other.usuarioCodigo != null) || (this.usuarioCodigo != null && !this.usuarioCodigo.equals(other.usuarioCodigo))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.cosmodas.dbcon.WcUsuarios[ usuarioCodigo=" + usuarioCodigo + " ]";
    }

}
